#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"
#include "globals.h"

/* Function definitions for the callbacks */

void btnAddClicked(GtkWidget *widget, GtkWidget *names_list)
{
	gchar *name, *address1, *address2, *city, *state, *zip;
	gchar *phone1, *phone2, *email, *misc;
	gchar *listText[1];
	FILE *database;
	char filename[256];
	
	/* retrieve all the text values from all the edit boxes */
	name     = gtk_entry_get_text( GTK_ENTRY(txtName) );
	address1 = gtk_entry_get_text( GTK_ENTRY(txtAddress1) );
	address2 = gtk_entry_get_text( GTK_ENTRY(txtAddress2) );
	city	 = gtk_entry_get_text( GTK_ENTRY(txtCity) );
	state	 = gtk_entry_get_text( GTK_ENTRY(txtState) );
	zip		 = gtk_entry_get_text( GTK_ENTRY(txtZipcode) );
	phone1	 = gtk_entry_get_text( GTK_ENTRY(txtPhone1) );
	phone2 	 = gtk_entry_get_text( GTK_ENTRY(txtPhone2) );
	email	 = gtk_entry_get_text( GTK_ENTRY(txtEmail) );
	misc	 = gtk_entry_get_text( GTK_ENTRY(txtMisc) );
	
	/* now add this entry to the user's personal address book and update the list box */
	strcpy(filename, getenv("HOME"));
	strcat(filename, "/.rolypoly_db");
	database = fopen(filename, "a");

	if (database == NULL)
		g_error("Couldn't open database file: %s for writing!\nCODE=01", filename);
	 
	/* write to disk */
	fprintf(database, "__BEGIN_SECTION__\n");
	fprintf(database, "%s\n%s\n%s\n", name, address1, address2);
	fprintf(database, "%s\n%s\n%s\n", city, state, zip);
	fprintf(database, "%s\n%s\n%s\n%s\n\n", phone1, phone2, email, misc);
	fclose(database);

	/* Now add the person's name to the Clist box */
	listText[0] = name;
	gtk_clist_append(GTK_CLIST(names_list), listText);

	clearAll(); /*reset contents of the edit boxes*/
	
}


void lstNamesClicked(GtkWidget *widget, gint row, gint col, GdkEventButton *event, gpointer data)
{
	FILE *database;
	char line[256], filename[256];
	int i, done=0;
	char *newline;
	
	/* set all the edit boxes to the entry corresponding to where the user clicked the
	 * list box.  Indexing starts from row 0.
	 */

	listRow = row;
	listCol = col;
	strcpy(filename, getenv("HOME"));	
	strcat(filename, "/.rolypoly_db");
	
	database = fopen(filename, "r");
	
	if (database == NULL)
		g_error("Couldn't open database file: %s for reading!\nCODE=02", filename);

	/* search the database file for the headings of a new section, and read in ROW many
	 * of these headings until we get to the entry we're looking for
	 */
	 i = 0;
	 if (fgets(line, 256, database) == NULL)
	 		g_error("Problems reading text from database file: %s\nCODE=03", filename);
	 while (!done)
	 {	 		
	 
	 	if (strstr(line, "__BEGIN_SECTION__") != NULL)
	 	{		 			 		
	 		if (++i <= row)
	 		{
	 			/* we still need to keep searching the file */
	 			while ( strstr( fgets(line, 256, database), "__BEGIN_SECTION__" ) == NULL )
	 			{
	 				if (line == NULL)
	 					g_error("Problems reading text from database file: %s\nCODE=04", filename);
	 			}
	 		}
	 		else
	 			done = 1;
	 	}
	 	else
	 	{	
	 		/* there's some garbage at the beginning of the database file, read until we
	 		 * get to a heading
	 		 */
	 		 while ( strstr( fgets(line, 256, database), "__BEGIN_SECTION__" ) == NULL)
	 		 {
	 		 	if (line == NULL)
	 		 		g_error("Problems reading text from database file: %s\nCODE=05", filename);
	 		 }
	 	}
	 }

	 /* now we're at the right place to read in the entry data. Strip any newline chars */

	 fgets(line, 256, database);
	 g_strstrip(line);
	 newline = strchr(line, '\n');
	 if (newline != NULL)
	 	*newline = '\0';
	 gtk_entry_set_text(GTK_ENTRY(txtName), line);
	 
	 fgets(line, 256, database);
	 g_strstrip(line);
	 newline = strchr(line, '\n');
	 if (newline != NULL)
	 	*newline = '\0';
	 gtk_entry_set_text(GTK_ENTRY(txtAddress1), line);
	 
	 fgets(line, 256, database);
	 g_strstrip(line);
	 newline = strchr(line, '\n');
	 if (newline != NULL)
	 	*newline = '\0';
	 gtk_entry_set_text(GTK_ENTRY(txtAddress2), line);
	 
	 fgets(line, 256, database);
	 g_strstrip(line);
	 newline = strchr(line, '\n');
	 if (newline != NULL)
	 	*newline = '\0';
	 gtk_entry_set_text(GTK_ENTRY(txtCity), line);
	 
	 fgets(line, 256, database);
	 g_strstrip(line);
	 newline = strchr(line, '\n');
	 if (newline != NULL)
	 	*newline = '\0';
	 gtk_entry_set_text(GTK_ENTRY(txtState), line);
	 
	 fgets(line, 256, database);
	 g_strstrip(line);
	 newline = strchr(line, '\n');
	 if (newline != NULL)
	 	*newline = '\0';
	 gtk_entry_set_text(GTK_ENTRY(txtZipcode), line);
	 
	 fgets(line, 256, database);
	 g_strstrip(line);
	 newline = strchr(line, '\n');
	 if (newline != NULL)
	 	*newline = '\0';
	 gtk_entry_set_text(GTK_ENTRY(txtPhone1), line);
	 
	 fgets(line, 256, database);
	 g_strstrip(line);
	 newline = strchr(line, '\n');
	 if (newline != NULL)
	 	*newline = '\0';
	 gtk_entry_set_text(GTK_ENTRY(txtPhone2), line);
	 
	 fgets(line, 256, database);
	 g_strstrip(line);
	 newline = strchr(line, '\n');
	 if (newline != NULL)
	 	*newline = '\0';
	 gtk_entry_set_text(GTK_ENTRY(txtEmail), line);
	 
	 fgets(line, 256, database);
	 g_strstrip(line);
	 newline = strchr(line, '\n');
	 if (newline != NULL)
	 	*newline = '\0';
	 gtk_entry_set_text(GTK_ENTRY(txtMisc), line);

	 fclose(database);

}


void lstAddNames(GtkWidget *widget, GtkWidget *names_list)
{
	FILE *database;
	char line[256], filename[256];
	gchar *textNames[1];

	/* Read in the names of all the people in the database and put them into the list box */
	strcpy(filename, getenv("HOME"));
	strcat(filename, "/.rolypoly_db");

	database = fopen(filename, "r");

	if (database == NULL)
		g_warning("No database file found, perhaps this is your first time running me?\n");
	else
	{

		while ( fgets(line, 256, database) != NULL )
		{
		
			if (strstr(line, "__BEGIN_SECTION__") != NULL)
			{
				/*we found the beginning of a section, add the name */
				if (fgets(line, 256, database) == NULL)
					g_error("Problems reading from the database file\nCODE=06");

					g_strstrip(line);
					textNames[0] = line;
					gtk_clist_append( GTK_CLIST(names_list), textNames );
				
			}
		}

		fclose(database);
	}

	
}


void clearAll(void)
{
	/* clear contents of all the edit boxes */
	gtk_entry_set_text(GTK_ENTRY(txtName), "");
	gtk_entry_set_text(GTK_ENTRY(txtAddress1), "");
	gtk_entry_set_text(GTK_ENTRY(txtAddress2), "");
	gtk_entry_set_text(GTK_ENTRY(txtCity), "");
	gtk_entry_set_text(GTK_ENTRY(txtState), "");
	gtk_entry_set_text(GTK_ENTRY(txtZipcode), "");
	gtk_entry_set_text(GTK_ENTRY(txtPhone1), "");
	gtk_entry_set_text(GTK_ENTRY(txtPhone2), "");
	gtk_entry_set_text(GTK_ENTRY(txtEmail), "");
	gtk_entry_set_text(GTK_ENTRY(txtMisc), "");
}

void clearBtn(GtkWidget *widget, gpointer data)
{
	clearAll();
}

void btnSaveClicked(GtkWidget *widget, GtkWidget *names_list)
{
	gchar *name, *address1, *address2, *city, *state, *zip;
	gchar *phone1, *phone2, *email, *misc;
	FILE *database, *temp;
	char filename[256], tempfile[256], line[256];
	int i, done=0;
	GtkWidget *notSelected;
	GtkWidget *nsLabel;
	GtkWidget *nsButton;
	
	/*make sure that something in the list box is already selected before trying
	 *to modify data =)
	 */
	if ( (listRow == -1) && (listCol == -1) )
	{
		nsLabel     = gtk_label_new("You need to select an entry from the list before you can modify it!\nUse ADD to create a new entry.");
		nsButton	= gtk_button_new_with_label("I have no choice but to press this button");
		notSelected = gtk_dialog_new();
		gtk_signal_connect_object( GTK_OBJECT(nsButton), "clicked", GTK_SIGNAL_FUNC(gtk_widget_destroy), GTK_OBJECT(notSelected) );
        gtk_container_add( GTK_CONTAINER( GTK_DIALOG(notSelected)->action_area ), nsButton);
        gtk_container_add( GTK_CONTAINER( GTK_DIALOG(notSelected)->vbox ), nsLabel);
		gtk_window_set_modal( GTK_WINDOW(notSelected), TRUE );
        gtk_widget_show_all(notSelected);
	}
	else
	{	
		/* retrieve all the text values from all the edit boxes */
		name     = gtk_entry_get_text( GTK_ENTRY(txtName) );
		address1 = gtk_entry_get_text( GTK_ENTRY(txtAddress1) );
		address2 = gtk_entry_get_text( GTK_ENTRY(txtAddress2) );
		city	 = gtk_entry_get_text( GTK_ENTRY(txtCity) );
		state	 = gtk_entry_get_text( GTK_ENTRY(txtState) );
		zip		 = gtk_entry_get_text( GTK_ENTRY(txtZipcode) );
		phone1	 = gtk_entry_get_text( GTK_ENTRY(txtPhone1) );
		phone2 	 = gtk_entry_get_text( GTK_ENTRY(txtPhone2) );
		email	 = gtk_entry_get_text( GTK_ENTRY(txtEmail) );
		misc	 = gtk_entry_get_text( GTK_ENTRY(txtMisc) );

		/* modify the user's database and update (if needed) the list box */
		strcpy(filename, getenv("HOME"));
		strcat(filename, "/.rolypoly_db");
		database = fopen(filename, "r");
		
		strcpy(tempfile, filename);
		strcat(tempfile, ".temp");
		temp     = fopen(tempfile, "w"); 

		if (temp == NULL)
			g_error("Couldn't create a temporary database file: %s for reading!\nCODE=07", tempfile);
		if (database == NULL)
			g_error("Couldn't open database file: %s for read mode!\nCODE=08", filename);

	 
		/* Loop through the file until we get to the section that needs to be updated */
		i = 0;
		 if (fgets(line, 256, database) == NULL)
		 		g_error("Problems reading text from database file: %s\nCODE=09", filename);
				
		 while (!done)
		 {		 	
		 	if (strstr(line, "__BEGIN_SECTION__") != NULL)
		 	{		 		
		 		/* it's the beginning of a section */
		 		if (++i <= listRow)
		 		{
		 			fprintf(temp, "%s", line);
		 			/* we still need to keep searching the file */
		 			while ( strstr( fgets(line, 256, database), "__BEGIN_SECTION__" ) == NULL )
		 			{		 				
		 				fprintf(temp, "%s", line);
		 				if (line == NULL)
		 					g_error("Problems reading text from database file: %s\nCODE=10", filename);
		 			}
		 		}
		 		else
		 		{
		 			fprintf(temp, "%s", line);
		 			done = 1;		 			
		 		}
		 		
		 	}
		 	else
		 	{	
		 		/* there's some garbage at the beginning of the database file, read until we
		 		 * get to a heading
		 		 */
		 		 while ( strstr( fgets(line, 256, database), "__BEGIN_SECTION__" ) == NULL)
		 		 {
		 		 	if (line == NULL)
		 		 		g_error("Problems reading text from database file: %s\nCODE=11", filename);
		 		 }
		 	}
		 }

		 /* now we're right where we need to be.  Insert the modified entry here.*/		  

		 fprintf(temp, "%s\n", name);
		 fprintf(temp, "%s\n", address1);
		 fprintf(temp, "%s\n", address2);
		 fprintf(temp, "%s\n", city);
		 fprintf(temp, "%s\n", state);
		 fprintf(temp, "%s\n", zip);
		 fprintf(temp, "%s\n", phone1);
		 fprintf(temp, "%s\n", phone2);
		 fprintf(temp, "%s\n", email);
		 fprintf(temp, "%s\n", misc);

		 /*Just read in 10 lines (the # of lines in an entry) to skip over the old data*/
		 for (i = 0; i < 10; i++)
		 {
		 	if (fgets(line, 256, database) == NULL)
		 		break;
		 }

		 /*now copy the rest of the file over to the temp file*/
		 while( fgets(line, 256, database) != NULL )
		 	fprintf(temp, "%s", line);
		 	
		 fclose(database); 
		 fclose(temp);

		 /*now copy the temp over the original databse*/
		 remove(filename);
		 rename(tempfile, filename);

		 /*update the list box*/
		 gtk_clist_set_text( GTK_CLIST(names_list), listRow, listCol, name );

		
	}
}


void btnDeleteClicked(GtkWidget *widget, GtkWidget *names_list)
{
	GtkWidget *nsLabel, *nsButton, *notSelected;
	FILE *database, *temp;
	char filename[256], line[256], tempfile[256];
	int i, done=0;
	
	/*make sure that something in the list box is already selected before trying
	 *to modify data =)
	 */
	if ( (listRow == -1) && (listCol == -1) )
	{
		nsLabel     = gtk_label_new("You need to select an entry from the list before you can delete it!\n");		nsButton	= gtk_button_new_with_label("I have no choice but to press this button");
		notSelected = gtk_dialog_new();
		gtk_signal_connect_object( GTK_OBJECT(nsButton), "clicked", GTK_SIGNAL_FUNC(gtk_widget_destroy), GTK_OBJECT(notSelected) );
        gtk_container_add( GTK_CONTAINER( GTK_DIALOG(notSelected)->action_area ), nsButton);
        gtk_container_add( GTK_CONTAINER( GTK_DIALOG(notSelected)->vbox ), nsLabel);
		gtk_window_set_modal( GTK_WINDOW(notSelected), TRUE );
        gtk_widget_show_all(notSelected);
	}
	else
	{
		/* modify the user's database and update (if needed) the list box */
		strcpy(filename, getenv("HOME"));
		strcat(filename, "/.rolypoly_db");
		database = fopen(filename, "r");

		strcpy(tempfile, filename);
		strcat(tempfile, ".temp");
		temp = fopen(tempfile, "w");

		if (database == NULL)
			g_error("Couldn't open database file: %s for read mode!\nCODE=12", filename);
		if (temp == NULL)
			g_error("Couldn't open tempfile: %s for write mod!\nCODE=16", tempfile);

	 
		/* Loop through the file until we get to the section that needs to be updated */
		i = 0;
		 if (fgets(line, 256, database) == NULL)
		 		g_error("Problems reading text from database file: %s\nCODE=13", filename);
		 while (!done)
		 {
		 
		 	if (strstr(line, "__BEGIN_SECTION__") != NULL)
		 	{		 		
		 		/* it's the beginning of a section */
		 		if (++i <= listRow)
		 		{
		 			fprintf(temp, "%s", line);
		 			/* we still need to keep searching the file */
		 			while ( strstr( fgets(line, 256, database), "__BEGIN_SECTION__" ) == NULL )
		 			{
		 				fprintf(temp, "%s", line);
		 				if (line == NULL)
		 					g_error("Problems reading text from database file: %s\nCODE=14", filename);
		 			}
		 		}
		 		else
		 			done = 1;
		 		
		 	}
		 	else
		 	{	
		 		/* there's some garbage at the beginning of the database file, read until we
		 		 * get to a heading
		 		 */
		 		 while ( strstr( fgets(line, 256, database), "__BEGIN_SECTION__" ) == NULL)
		 		 {
		 		 	if (line == NULL)
		 		 		g_error("Problems reading text from database file: %s\nCODE=15", filename);
		 		 }
		 	}
		 }

		 /* now we're right where we need to be.  Just skip over the next 10 lines (the # of lines
		  * in an entry) and copy the rest of teh file to disk*/
		 /*Just read in 10 lines (the # of lines in an entry) to skip over the old data*/
		 for (i = 0; i < 10; i++)
		 {
		 	if ( fgets(line, 256, database) == NULL )
		 		break;
		 }

		 /*now copy the rest of the file over to the temp file*/
		 while( fgets(line, 256, database) != NULL )
		 	fprintf(temp, "%s", line);
		 	
		 fclose(database); 
		 fclose(temp);

		 /*now copy the temp over the original databse*/
		 remove(filename);
		 rename(tempfile, filename);

		/*update the list box*/
		 gtk_clist_remove( GTK_CLIST(names_list), listRow );

		/* clear the text boxes */
		clearAll();
	}

}
